(function() {
  var connect, crypto, exec, opt, requireModule, runServer, sharejs, sys;
  requireModule = function(filename) {
    try {
      return require(filename);
    } catch (error) {
      return require("" + __dirname + "/node_modules/" + filename);
    }
  };
  opt = requireModule('optimist').usage('Collaborative writing with Markdown & Textile.\nUsage: $0 [-p port -d database]').options('p', {
    alias: 'port',
    "default": process.env.PORT || process.env.npm_package_config_port || 3000,
    describe: 'Runs escrito on the specified port.'
  }).options('d', {
    alias: 'database',
    "default": process.env.npm_package_config_database || 'memory',
    describe: "Uses the specified database type. Supported values are 'memory' and 'redis'."
  }).alias('h', 'help');
  if (opt.argv.h) {
    opt.showHelp();
    process.exit();
  }
  runServer = function(argv, sharejs, connect, sys, crypto) {
    var options, server;
    server = connect(connect.favicon(__dirname + '/public/favicon.ico'), connect.logger(), connect.static(__dirname + '/public'), connect.router(function(app) {
      var editor;
      editor = require('./editor');
      app.get('/?', function(req, res, next) {
        var uid;
        uid = crypto.createHash('md5').update("" + (new Date()).getTime()).digest("hex").toString().substring(0, 9);
        res.writeHead(301, {
          location: "/" + uid
        });
        return res.end();
      });
      return app.get('/:docName', function(req, res, next) {
        var docName;
        docName = req.params.docName;
        return editor(argv.p, docName, server.model, res, next);
      });
    }));
    options = {
      db: {
        type: argv.d
      }
    };
    sharejs.attach(server, options);
    server.listen(argv.p);
    return sys.puts("Escrito is running at http://localhost:" + argv.p + "/");
  };
  connect = requireModule('connect');
  crypto = requireModule('crypto');
  sys = require('sys');
  try {
    sharejs = requireModule('share').server;
    runServer(opt.argv);
  } catch (error) {
    exec = require('child_process').exec;
    exec("cd " + __dirname + " && cake build-dependencies", function(err, stdout, stderr) {
      var sharejs;
      if (err) {
        throw err;
      }
      sharejs = requireModule('share').server;
      return runServer(opt.argv, sharejs, connect, sys, crypto);
    });
  }
}).call(this);
